﻿-- Objective Cleanup
if not Cleanup then
  Cleanup = true;

  local frame, events = CreateFrame("Frame"), {};

--  function events:QUEST_QUERY_COMPLETE()
--    print("Pulling Complete Quests: Done!");
--    TradeSkillDB["completedquest"] = GetQuestsCompleted();
--    print("Complete Quests Saved!");
--  end
    
  -- Fire this script when Tour Guide - Trade Skill addon is loaded
  function events:ADDON_LOADED(addon)
    if (addon == "TourGuide-Tradeskill") then
      print("TourGuide - Trade Skill: Loaded");
      if (TradeSkillDB == nil) then
        TradeSkillDB = {};
      end
      CurentGuide = TradeSkillDB["guide"];
      if (CurentGuide == nil) then
        CurentGuide = "No Guide";
      end
      
      -- Create UnknownRecipe table in DB if not there
      if not TradeSkillDB["UnknownRecipe"] then
        TradeSkillDB["UnknownRecipe"] = {}
      end
--      print("Pulling Complete Quests: Startet!");
--      QueryQuestsCompleted();
    end
  end

  frame:SetScript("OnEvent",
    function(self, event, ...)
      events[event](self, ...)
    end
  )

  frame:SetScript("OnUpdate",
    function(LastUpdate)
      if not (CurentGuide == TourGuide.db.char.currentguide) then
        --print("Guide Changed!");
        TradeSkillDB["guide"] = TourGuide.db.char.currentguide;
        CurentGuide = TradeSkillDB["guide"];

        -- Cleanup
        for i, t in ipairs(TourGuide.tags) do
          local done = false
          -- Cleanup level opjectives that is done
          if (t:match("|LVL|(%d+)|")) then
            lvl = tonumber(t:match("|LVL|(%d+)|"))
            if lvl and lvl <= UnitLevel("Player") then TourGuide:SetTurnedIn(i, true, true) end
            done = true
          end
          
          -- Cleanup skills
          if (not done) and (t:match("|SKILL|(.+)|")) then
            -- Get Skill info to check
            local info = { strsplit(",", t:match("|SKILL|(.+)|")) }
            local numDone = 0
            
            for infoIndex = 1, #info, 1 do
              if strlen(strtrim(info[infoIndex])) > 0 then
                local SkillName, SkillLevel = info[infoIndex]:match("([%a:%s]+)%s?(%d+)");
                SkillName = strtrim(SkillName);
                SkillLevel = tonumber(SkillLevel) or 1;

                -- Loop all curent skill and check if the skill match
                for _, sID in ipairs(TG_TS_GetProfessions()) do
                  if sID then
                    local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)
                    if SkillName == sName and SkillLevel <= tonumber(sLevel) then
                      numDone = numDone + 1
                    end
                  end
                end
              -- ensure that it will complete even that there is a , to mutch
              else
                numDone = numDone + 1
              end
            end
            
            if numDone >= #info then
              TourGuide:SetTurnedIn(i, true, true);
              done = true
            end
          end

          -- Cleanup level to skills
          if (not done) and (t:match("|LVLTOSKILL|([%a:%s]+)%s?(%d*)|")) then
            -- Get Skill info to check
            local _, _, SkillName, SkillLevel = t:find("|LVLTOSKILL|([%a:%s]+)%s?(%d*)|");
            SkillName = strtrim(SkillName);
            SkillLevel = tonumber(SkillLevel) or 1;

            -- Loop all curent skill and check if the skill match
            local skills = TG_TS_GetProfessions();
            for _, sID in ipairs(skills) do
              if sID then
                local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)

                if SkillName == strtrim(sName) and SkillLevel <= tonumber(sLevel) then
                  TourGuide:SetTurnedIn(i, true, true);
                  done = true
                end
              end
            end
          end

          -- Cleanup Tradeskill
          if (not done) and t:match("|TRAINSKILL|([%a:%s]+)%s?(%d*)|") then
            -- Get Skill info to check
            local _, _, SkillName, MaxSkillLevel = t:find("|TRAINSKILL|([%a:%s]+)%s?(%d*)|");
            SkillName = strtrim(SkillName);
            MaxSkillLevel = tonumber(MaxSkillLevel) or 75;

            -- Loop all curent skill and check if the skill match
            local skills = TG_TS_GetProfessions();
            for _, sID in ipairs(skills) do
              if sID then
                local sName, _, _, maxSLevel, _, _, _, _ = GetProfessionInfo(sID)
                if SkillName == strtrim(sName) and MaxSkillLevel <= tonumber(maxSLevel) then
                  TourGuide:SetTurnedIn(i, true, true);
                  done = true
                end
              end
            end
          end
        end
        -- print("Guide Cleanup Done");
      end
    end
  )

  for k, v in pairs(events) do
    frame:RegisterEvent(k)
  end
end