﻿-- Compleater
if not Completer then
  Completer = true;

  local frame, events, playSound, expired, guideId, infoFader = CreateFrame("Frame"), {}, 0, 0, 0, 0;
  -- Timers
  local timer, timer025, timer1, timer5, secLeft = 0, 0, 0, 0, 0;
  -- Table of fishing poles
  local fishpoles = {6256,6365,6366,6367,12225,19022,19970,25978,44050,45858,45991,45992,46337,52678};

  -- check skill level and skill training
  function events:CHAT_MSG_SKILL(msg)
    -- Check if there is a SKILL tag
    if TourGuide.tags[TourGuide.current]:match("|SKILL|") then TG_TS_SKILL() end

    -- Check if there is a LVLTOSKILL tag
    if TourGuide.tags[TourGuide.current]:match("|LVLTOSKILL|") then TG_TS_LVLTOSKILL() end
  end

  -- Check for new learned item recipe
  function events:CHAT_MSG_SYSTEM(msg, ...)
    -- Remove profession from DB if a profession is unlearned and clear UnknownRecipe from DB so there will not be any mix ups
    if msg:match("You have unlearned |cff71d5ff|Hspell:%d+|h%[(.+)%]|h|r.") then
      local ProfName = msg:match("You have unlearned |cff71d5ff|Hspell:%d+|h%[(.+)%]|h|r.")
      if TradeSkillDB[ProfName] then TradeSkillDB[ProfName] = nil end
      TradeSkillDB["UnknownRecipe"] = {}
    end

    -- Check if there is a TRAINSKILL tag
    if msg:match("You have learned a new ability: (.+).") and TourGuide.tags[TourGuide.current]:match("|TRAINSKILL|") then
      TG_TS_TRAINSKILL(msg)
    end

    -- Check if there is a LEARNITEM tag
    if msg:match("You have learned how to create a new item: ([%a:%s]+).") then
      tinsert(TradeSkillDB["UnknownRecipe"], msg:match("You have learned how to create a new item: ([%a:%s]+)."))
      if TourGuide.tags[TourGuide.current]:match("|LEARNITEM|") then TG_TS_LEARNITEM(msg) end
    end
  end

  -- Check for currentcy change
  function events:CURRENCY_DISPLAY_UPDATE()
    if TourGuide.tags and TourGuide.tags[TourGuide.current]:match("|CURRENCY|") then TG_TS_CURRENCY() end
  end

  -- Check for bag updates
  function events:BAG_UPDATE(bId)
    -- If bag id is 0-4 then execute script
    if bId >= 0 and bId <= 4 then
      -- Check if there is a LOOT tag
      if TourGuide.tags[TourGuide.current]:match("|LOOT|") then TG_TS_LOOT() end
    end
  end

  -- Check for player level up
  function events:PLAYER_LEVEL_UP(level)
    if TourGuide.tags[TourGuide.current]:match("|LVL|") then TG_TS_LVL(level) end
  end

  -- Update Recipe/Plan Saved list
  function events:TRADE_SKILL_SHOW()
    local tradeskillName, _, _  = GetTradeSkillLine()
    TG_TS_UPDATESKILLLIST(tradeskillName)
  end

  frame:SetScript("OnEvent",
    function(self, event, ...)
      events[event](self, ...)
    end
  )

  for k, v in pairs(events) do
    frame:RegisterEvent(k)
  end

  frame:SetScript("OnUpdate",
    function(Self,LastUpdate)
      -- Make sure TourGuide addon is loaded
      if IsAddOnLoaded("TourGuide") and IsAddOnLoaded("TourGuide-Tradeskill") then
        ---------------------------------------
        -- Cleanup Controller
        ---------------------------------------
        if guideId ~= TourGuide.current then
          guideId = TourGuide.current
          local done = false;
          -- Hide the Extra Info Frame so it's ready to update
          TourGuide.statusframe.extend:Hide();

          -- Hide the map icon so it's ready to update
          TourGuide.statusframe.Map:Hide()

          -- Check CURRENCY tag
          if TourGuide.tags[TourGuide.current]:match("|CURRENCY|") then
            done = TG_TS_CURRENCY();
          end

          -- Check DONTHAVESKILL tag
          if TourGuide.tags[TourGuide.current]:match("|DONTHAVESKILL|") and done == false then
            done = TG_TS_DONTHAVESKILL();
          end

          -- Check HAVESKILL tag
          if TourGuide.tags[TourGuide.current]:match("|HAVESKILL|") and done == false then
            done = TG_TS_HAVESKILL();
          end

          -- Check LEARNITEM tag
          if TourGuide.tags[TourGuide.current]:match("|LEARNITEM|") and done == false then
            done = TG_TS_LEARNITEM();
          end

          -- Check LOOT tag
          if TourGuide.tags[TourGuide.current]:match("|LOOT|") and done == false then
            done = TG_TS_LOOT();
          end

          -- Check LVL tag
          if (TourGuide.tags[TourGuide.current]:match("|LVL|")) and done == false then
            done = TG_TS_LVL();
          end

          -- Check LVLTOSKILL tag
          if TourGuide.tags[TourGuide.current]:match("|LVLTOSKILL|") and done == false then
            done = TG_TS_LVLTOSKILL();
          end

          -- Check MAP tag
          if TourGuide.tags[TourGuide.current]:match("|MAP|") and done == false then
            done = TG_TS_MAP();
          end

          -- Check SKILL tag
          if TourGuide.tags[TourGuide.current]:match("|SKILL|") and done == false then
            done = TG_TS_SKILL();
          end

          -- Check TRAINSKILL tag
          if TourGuide.tags[TourGuide.current]:match("|TRAINSKILL|") and done == false then
            done = TG_TS_TRAINSKILL();
          end
          done = false;
        end -- if guideId

        ---------------------------------------
        -- End Cleanup Controller
        ---------------------------------------

        ---------------------------------------
        -- Extra Info Frame Controller
        ---------------------------------------
        if not TourGuide.statusframe.extend:IsShown() then
          if TourGuide.tags[TourGuide.current]:match("|LVLTOSKILL|") or TourGuide.tags[TourGuide.current]:match("|LOOT|") or TourGuide.tags[TourGuide.current]:match("|CURRENCY|") then
            TourGuide.statusframe.extend:Show();
          end
        end
        ---------------------------------------
        -- End Extra Info Frame Controller
        ---------------------------------------

        ---------------------------------------
        -- Map Tag Controller
        ---------------------------------------
        if (not TourGuide.statusframe.Map:IsShown()) then
          if TourGuide.tags[TourGuide.current]:match("|MAP|") then
            TourGuide.statusframe.Map:Show()
          end
        end
        ---------------------------------------
        -- End Map Tag Controller
        ---------------------------------------

        ---------------------------------------
        -- Lure alert sound controller
        ---------------------------------------
        -- only run this script if |U|se tag is presended
        -- This is used for warning bip when lure is almost runned out
        if TourGuide.tags[TourGuide.current]:match("|U|") then
          -- check if player have a fishing pole equipped
          for i,v in ipairs(fishpoles) do
            local poleName = GetItemInfo(v);
            local poleEquipped = IsEquippedItem(v);
            if poleEquipped then
              hasMainHandEnchant, mainHandExpiration = GetWeaponEnchantInfo();
              -- Play sound if fishing pole have lures on it that is soon to run out
              if hasMainHandEnchant then
                secLeft = floor(mainHandExpiration/1000);

                -- Show that enchant expired
                if secLeft <= 0 and expired == 0 then
                  print(string.format("|cffffff00%s|r |cFFFF6060lure expired|r",poleName));
                  expired = 1;

                -- Play bip fast
                elseif secLeft < 1 and expired == 0 then
                  timer025 = timer025 + LastUpdate;
                  if timer025 >= 0.25 then
                    timer025 = timer025 - 0.25;
                    playSound = 1;
                  end

                -- Play bip each second
                elseif secLeft <= 5 and expired == 0 then
                  timer1 = timer1 + LastUpdate;
                  if timer1 >= 1 then
                    timer1 = timer1 - 1;
                    playSound = 1;
                    print(string.format("|cffffff00%s|r |cFFFF6060lure expire in: %isec|r",poleName,secLeft));
                  end

                -- Play bip each 5 second
                elseif secLeft <= 20 then
                  timer5 = timer5 + LastUpdate;
                  if timer5 >= 5 then
                    timer5 = timer5 - 5;
                    playSound = 1;
                    print(string.format("|cffffff00%s|r |cFFFF6060lure expire in: %isec|r",poleName,secLeft));
                  end

                -- Reset 1 and 5 sec counter if not reset
                elseif secLeft > 20 and timer5 ~= 0 or timer1 ~= 0 or expired ~= 0 then
                  timer1 = 0;
                  timer5 = 0;
                  expired = 0;
                end

                if playSound == 1 then
                  PlaySoundFile("Interface\\AddOns\\TourGuide-Tradeskill\\Sounds\\bip.mp3", "SFX");
                  playSound = 0;
                end -- if playSound
              else
                if expired ~= 0 then expired = 0 end
              end -- if hasMainHandEnchant
            end -- if poleEquipped
          end -- for i,v
        end -- if TourGuide.tags
        ---------------------------------------
        -- End Lure alert sound controller
        ---------------------------------------
      end -- if IsAddOnLoaded
    end -- function
  )
end